<script setup lang="ts">
    import { computed } from 'vue'
    import { InterventionHistorisedStatus } from '@/interventionServiceOffer/entities/intervention/status/InterventionHistorisedStatus'

    const props = defineProps<{
        interventionStatuses: Array<InterventionHistorisedStatus>
    }>()

    const sortedInterventionStatuses = computed(() => {
        return [...props.interventionStatuses].sort(
            (interventionStatusA, interventionStatusB) => {
                return (
                    interventionStatusB.createdAt.valueOf() -
                    interventionStatusA.createdAt.valueOf()
                )
            }
        )
    })
</script>
<template>
    <v-timeline
        class="d-print-none"
        data-cy="intervention-status-history"
        density="compact"
    >
        <v-timeline-item
            v-for="interventionStatus in sortedInterventionStatuses"
            :key="interventionStatus.createdAt.valueOf()"
            data-cy="intervention-status"
            size="small"
            dot-color="white"
        >
            <p>
                <strong>{{ interventionStatus.label }}</strong>
                par <em>{{ interventionStatus.createdBy }}</em> le
                {{ interventionStatus.createdAt.toLocaleDateString() }}
            </p>
        </v-timeline-item>
    </v-timeline>

    <h3 class="d-none d-print-block">
        Historique des états <v-icon> mdi-history </v-icon>
    </h3>
    <ul class="d-none d-print-block" style="list-style-type: none">
        <li
            v-for="interventionStatus in sortedInterventionStatuses"
            :key="interventionStatus.createdAt.valueOf()"
            class="pl-3"
        >
            <strong>{{ interventionStatus.label }}</strong>
            par <em>{{ interventionStatus.createdBy }}</em> le
            {{ interventionStatus.createdAt.toLocaleDateString() }}
        </li>
    </ul>
</template>
